// -*-c++-*-
/* This file was automatically generated by rpcc. */

#ifndef __RPCC_SFS_PROT_H_INCLUDED__
#define __RPCC_SFS_PROT_H_INCLUDED__ 1

#include "xdrmisc.h"
#include "bigint.h"
#include "nfs3exp_prot.h"

enum { SFS_PORT = 4 };
enum { SFS_RELEASE = 1 };

enum sfsstat {
  SFS_OK = 0,
  SFS_BADLOGIN = 1,
  SFS_NOSUCHHOST = 2,
  SFS_NOTSUPP = 10004,
  SFS_TEMPERR = 10008,
};
void *sfsstat_alloc ();
bool_t xdr_sfsstat (XDR *, void *);
RPC_ENUM_DECL (sfsstat)

template<class T> inline bool
rpc_traverse (T &t, sfsstat &obj)
{
  u_int32_t val = obj;
  if (!rpc_traverse (t, val))
    return false;
  obj = sfsstat (val);
  return true;
}

enum sfs_msgtype {
  SFS_HOSTINFO = 1,
  SFS_KSC = 2,
  SFS_KCS = 3,
  SFS_SESSINFO = 4,
  SFS_AUTHINFO = 5,
  SFS_SIGNED_AUTHREQ = 6,
  SFS_AUTHREGISTER = 7,
  SFS_AUTHUPDATE = 8,
};
void *sfs_msgtype_alloc ();
bool_t xdr_sfs_msgtype (XDR *, void *);
RPC_ENUM_DECL (sfs_msgtype)

template<class T> inline bool
rpc_traverse (T &t, sfs_msgtype &obj)
{
  u_int32_t val = obj;
  if (!rpc_traverse (t, val))
    return false;
  obj = sfs_msgtype (val);
  return true;
}

enum sfs_service {
  SFS_SFS = 1,
  SFS_AUTHSERV = 2,
};
void *sfs_service_alloc ();
bool_t xdr_sfs_service (XDR *, void *);
RPC_ENUM_DECL (sfs_service)

template<class T> inline bool
rpc_traverse (T &t, sfs_service &obj)
{
  u_int32_t val = obj;
  if (!rpc_traverse (t, val))
    return false;
  obj = sfs_service (val);
  return true;
}

typedef rpc_str<RPC_INFINITY> sfs_extension;
void *sfs_extension_alloc ();
bool_t xdr_sfs_extension (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_extension)

typedef rpc_str<255> sfs_hostname;
void *sfs_hostname_alloc ();
bool_t xdr_sfs_hostname (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_hostname)

typedef rpc_opaque<20> sfs_hash;
void *sfs_hash_alloc ();
bool_t xdr_sfs_hash (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_hash)

typedef rpc_opaque<16> sfs_secret;
void *sfs_secret_alloc ();
bool_t xdr_sfs_secret (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_secret)

typedef u_int64_t sfs_seqno;
void *sfs_seqno_alloc ();
bool_t xdr_sfs_seqno (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_seqno)

typedef bigint sfs_pubkey;
void *sfs_pubkey_alloc ();
bool_t xdr_sfs_pubkey (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_pubkey)

typedef bigint sfs_ctext;
void *sfs_ctext_alloc ();
bool_t xdr_sfs_ctext (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_ctext)

typedef bigint sfs_sig;
void *sfs_sig_alloc ();
bool_t xdr_sfs_sig (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_sig)


struct sfs_hashcharge {
  u_int32_t bitcost;
  sfs_hash target;
};
void *sfs_hashcharge_alloc ();
bool_t xdr_sfs_hashcharge (XDR *, void *);
RPC_STRUCT_DECL (sfs_hashcharge)

template<class T> bool
rpc_traverse (T &t, sfs_hashcharge &obj)
{
  return rpc_traverse (t, obj.bitcost)
    && rpc_traverse (t, obj.target);
}


typedef rpc_opaque<64> sfs_hashpay;
void *sfs_hashpay_alloc ();
bool_t xdr_sfs_hashpay (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_hashpay)


struct sfs_hostinfo {
  sfs_msgtype type;
  sfs_hostname hostname;
  sfs_pubkey pubkey;
};
void *sfs_hostinfo_alloc ();
bool_t xdr_sfs_hostinfo (XDR *, void *);
RPC_STRUCT_DECL (sfs_hostinfo)

template<class T> bool
rpc_traverse (T &t, sfs_hostinfo &obj)
{
  return rpc_traverse (t, obj.type)
    && rpc_traverse (t, obj.hostname)
    && rpc_traverse (t, obj.pubkey);
}



struct sfs_sesskeydat {
  sfs_msgtype type;
  sfs_pubkey ks;
  sfs_secret sshare;
  sfs_pubkey kc;
  sfs_secret cshare;
};
void *sfs_sesskeydat_alloc ();
bool_t xdr_sfs_sesskeydat (XDR *, void *);
RPC_STRUCT_DECL (sfs_sesskeydat)

template<class T> bool
rpc_traverse (T &t, sfs_sesskeydat &obj)
{
  return rpc_traverse (t, obj.type)
    && rpc_traverse (t, obj.ks)
    && rpc_traverse (t, obj.sshare)
    && rpc_traverse (t, obj.kc)
    && rpc_traverse (t, obj.cshare);
}



struct sfs_sessinfo {
  sfs_msgtype type;
  rpc_bytes<RPC_INFINITY> ksc;
  rpc_bytes<RPC_INFINITY> kcs;
};
void *sfs_sessinfo_alloc ();
bool_t xdr_sfs_sessinfo (XDR *, void *);
RPC_STRUCT_DECL (sfs_sessinfo)

template<class T> bool
rpc_traverse (T &t, sfs_sessinfo &obj)
{
  return rpc_traverse (t, obj.type)
    && rpc_traverse (t, obj.ksc)
    && rpc_traverse (t, obj.kcs);
}



struct sfs_authinfo {
  sfs_msgtype type;
  sfs_service service;
  sfs_hostname name;
  sfs_hash hostid;
  sfs_hash sessid;
};
void *sfs_authinfo_alloc ();
bool_t xdr_sfs_authinfo (XDR *, void *);
RPC_STRUCT_DECL (sfs_authinfo)

template<class T> bool
rpc_traverse (T &t, sfs_authinfo &obj)
{
  return rpc_traverse (t, obj.type)
    && rpc_traverse (t, obj.service)
    && rpc_traverse (t, obj.name)
    && rpc_traverse (t, obj.hostid)
    && rpc_traverse (t, obj.sessid);
}



struct sfs_kmsg {
  sfs_secret kcs_share;
  sfs_secret ksc_share;
};
void *sfs_kmsg_alloc ();
bool_t xdr_sfs_kmsg (XDR *, void *);
RPC_STRUCT_DECL (sfs_kmsg)

template<class T> bool
rpc_traverse (T &t, sfs_kmsg &obj)
{
  return rpc_traverse (t, obj.kcs_share)
    && rpc_traverse (t, obj.ksc_share);
}



struct sfs_signed_authreq {
  sfs_msgtype type;
  sfs_hash authid;
  sfs_seqno seqno;
  rpc_opaque<16> usrinfo;
};
void *sfs_signed_authreq_alloc ();
bool_t xdr_sfs_signed_authreq (XDR *, void *);
RPC_STRUCT_DECL (sfs_signed_authreq)

template<class T> bool
rpc_traverse (T &t, sfs_signed_authreq &obj)
{
  return rpc_traverse (t, obj.type)
    && rpc_traverse (t, obj.authid)
    && rpc_traverse (t, obj.seqno)
    && rpc_traverse (t, obj.usrinfo);
}



struct sfs_connectarg {
  u_int32_t release;
  sfs_service service;
  sfs_hostname name;
  sfs_hash hostid;
  rpc_vec<sfs_extension, RPC_INFINITY> extensions;
};
void *sfs_connectarg_alloc ();
bool_t xdr_sfs_connectarg (XDR *, void *);
RPC_STRUCT_DECL (sfs_connectarg)

template<class T> bool
rpc_traverse (T &t, sfs_connectarg &obj)
{
  return rpc_traverse (t, obj.release)
    && rpc_traverse (t, obj.service)
    && rpc_traverse (t, obj.name)
    && rpc_traverse (t, obj.hostid)
    && rpc_traverse (t, obj.extensions);
}



struct sfs_connectok {
  int32_t release;
  sfs_hostinfo host;
  int32_t prog;
  int32_t vers;
  sfs_hashcharge charge;
};
void *sfs_connectok_alloc ();
bool_t xdr_sfs_connectok (XDR *, void *);
RPC_STRUCT_DECL (sfs_connectok)

template<class T> bool
rpc_traverse (T &t, sfs_connectok &obj)
{
  return rpc_traverse (t, obj.release)
    && rpc_traverse (t, obj.host)
    && rpc_traverse (t, obj.prog)
    && rpc_traverse (t, obj.vers)
    && rpc_traverse (t, obj.charge);
}



struct sfs_connectres {
  const sfsstat status;
  union {
    union_entry_base _base;
    union_entry<sfs_connectok> reply;
  };

#define rpcunion_tag_sfs_connectres status
#define rpcunion_switch_sfs_connectres(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case SFS_OK: \
    action (sfs_connectok, reply); \
    break; \
  default: \
    voidaction; \
    break; \
  }

  sfs_connectres (sfsstat _tag = (sfsstat) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfs_connectres (const sfs_connectres &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfs_connectres () { _base.destroy (); }
  sfs_connectres &operator= (const sfs_connectres &_s) {
    const_cast<sfsstat &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (sfsstat _tag) {
    const_cast<sfsstat &> (status) = _tag;
    rpcunion_switch_sfs_connectres
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfs_connectres &obj)
{
  sfsstat tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfs_connectres
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfs_connectres &obj)
{
  rpcunion_switch_sfs_connectres
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfs_connectres_alloc ();
bool_t xdr_sfs_connectres (XDR *, void *);
RPC_UNION_DECL (sfs_connectres)



struct sfs_encryptarg {
  sfs_hashpay payment;
  sfs_ctext kmsg;
  sfs_pubkey pubkey;
};
void *sfs_encryptarg_alloc ();
bool_t xdr_sfs_encryptarg (XDR *, void *);
RPC_STRUCT_DECL (sfs_encryptarg)

template<class T> bool
rpc_traverse (T &t, sfs_encryptarg &obj)
{
  return rpc_traverse (t, obj.payment)
    && rpc_traverse (t, obj.kmsg)
    && rpc_traverse (t, obj.pubkey);
}


typedef sfs_ctext sfs_encryptres;
void *sfs_encryptres_alloc ();
bool_t xdr_sfs_encryptres (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_encryptres)


struct sfs_nfs3_subfs {
  nfspath3 path;
  nfs_fh3 fh;
};
void *sfs_nfs3_subfs_alloc ();
bool_t xdr_sfs_nfs3_subfs (XDR *, void *);
RPC_STRUCT_DECL (sfs_nfs3_subfs)

template<class T> bool
rpc_traverse (T &t, sfs_nfs3_subfs &obj)
{
  return rpc_traverse (t, obj.path)
    && rpc_traverse (t, obj.fh);
}



struct sfs_nfs3_fsinfo {
  nfs_fh3 root;
  rpc_vec<sfs_nfs3_subfs, RPC_INFINITY> subfs;
};
void *sfs_nfs3_fsinfo_alloc ();
bool_t xdr_sfs_nfs3_fsinfo (XDR *, void *);
RPC_STRUCT_DECL (sfs_nfs3_fsinfo)

template<class T> bool
rpc_traverse (T &t, sfs_nfs3_fsinfo &obj)
{
  return rpc_traverse (t, obj.root)
    && rpc_traverse (t, obj.subfs);
}



struct sfs_nfs_fsinfo {
  const int32_t vers;
  union {
    union_entry_base _base;
    union_entry<sfs_nfs3_fsinfo> v3;
  };

#define rpcunion_tag_sfs_nfs_fsinfo vers
#define rpcunion_switch_sfs_nfs_fsinfo(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case ex_NFS_V3: \
    action (sfs_nfs3_fsinfo, v3); \
    break; \
  default: \
    defaction; \
    break; \
  }

  sfs_nfs_fsinfo (int32_t _tag = (int32_t) 0) : vers (_tag)
    { _base.init (); set_vers (_tag); }
  sfs_nfs_fsinfo (const sfs_nfs_fsinfo &_s)
    : vers (_s.vers)
    { _base.init (_s._base); }
  ~sfs_nfs_fsinfo () { _base.destroy (); }
  sfs_nfs_fsinfo &operator= (const sfs_nfs_fsinfo &_s) {
    const_cast<int32_t &> (vers) = _s.vers;
    _base.assign (_s._base);
    return *this;
  }

  void set_vers (int32_t _tag) {
    const_cast<int32_t &> (vers) = _tag;
    rpcunion_switch_sfs_nfs_fsinfo
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfs_nfs_fsinfo &obj)
{
  int32_t tag = obj.vers;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.vers)
    obj.set_vers (tag);

  rpcunion_switch_sfs_nfs_fsinfo
    (obj.vers, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfs_nfs_fsinfo &obj)
{
  rpcunion_switch_sfs_nfs_fsinfo
    (obj.vers, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfs_nfs_fsinfo_alloc ();
bool_t xdr_sfs_nfs_fsinfo (XDR *, void *);
RPC_UNION_DECL (sfs_nfs_fsinfo)



struct sfs_fsinfo {
  const int32_t prog;
  union {
    union_entry_base _base;
    union_entry<sfs_nfs_fsinfo> nfs;
  };

#define rpcunion_tag_sfs_fsinfo prog
#define rpcunion_switch_sfs_fsinfo(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case ex_NFS_PROGRAM: \
    action (sfs_nfs_fsinfo, nfs); \
    break; \
  default: \
    voidaction; \
    break; \
  }

  sfs_fsinfo (int32_t _tag = (int32_t) 0) : prog (_tag)
    { _base.init (); set_prog (_tag); }
  sfs_fsinfo (const sfs_fsinfo &_s)
    : prog (_s.prog)
    { _base.init (_s._base); }
  ~sfs_fsinfo () { _base.destroy (); }
  sfs_fsinfo &operator= (const sfs_fsinfo &_s) {
    const_cast<int32_t &> (prog) = _s.prog;
    _base.assign (_s._base);
    return *this;
  }

  void set_prog (int32_t _tag) {
    const_cast<int32_t &> (prog) = _tag;
    rpcunion_switch_sfs_fsinfo
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfs_fsinfo &obj)
{
  int32_t tag = obj.prog;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.prog)
    obj.set_prog (tag);

  rpcunion_switch_sfs_fsinfo
    (obj.prog, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfs_fsinfo &obj)
{
  rpcunion_switch_sfs_fsinfo
    (obj.prog, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfs_fsinfo_alloc ();
bool_t xdr_sfs_fsinfo (XDR *, void *);
RPC_UNION_DECL (sfs_fsinfo)


typedef rpc_str<32> sfs_idname;
void *sfs_idname_alloc ();
bool_t xdr_sfs_idname (XDR *, void *);
RPC_TYPEDEF_DECL (sfs_idname)


struct sfs_opt_idname {
  const bool present;
  union {
    union_entry_base _base;
    union_entry<sfs_idname> name;
  };

#define rpcunion_tag_sfs_opt_idname present
#define rpcunion_switch_sfs_opt_idname(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case true: \
    action (sfs_idname, name); \
    break; \
  case false: \
    voidaction; \
    break; \
  default: \
    defaction; \
    break; \
  }

  sfs_opt_idname (bool _tag = (bool) 0) : present (_tag)
    { _base.init (); set_present (_tag); }
  sfs_opt_idname (const sfs_opt_idname &_s)
    : present (_s.present)
    { _base.init (_s._base); }
  ~sfs_opt_idname () { _base.destroy (); }
  sfs_opt_idname &operator= (const sfs_opt_idname &_s) {
    const_cast<bool &> (present) = _s.present;
    _base.assign (_s._base);
    return *this;
  }

  void set_present (bool _tag) {
    const_cast<bool &> (present) = _tag;
    rpcunion_switch_sfs_opt_idname
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfs_opt_idname &obj)
{
  bool tag = obj.present;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.present)
    obj.set_present (tag);

  rpcunion_switch_sfs_opt_idname
    (obj.present, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfs_opt_idname &obj)
{
  rpcunion_switch_sfs_opt_idname
    (obj.present, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfs_opt_idname_alloc ();
bool_t xdr_sfs_opt_idname (XDR *, void *);
RPC_UNION_DECL (sfs_opt_idname)



struct sfs_idnums {
  int32_t uid;
  int32_t gid;
};
void *sfs_idnums_alloc ();
bool_t xdr_sfs_idnums (XDR *, void *);
RPC_STRUCT_DECL (sfs_idnums)

template<class T> bool
rpc_traverse (T &t, sfs_idnums &obj)
{
  return rpc_traverse (t, obj.uid)
    && rpc_traverse (t, obj.gid);
}



struct sfs_idnames {
  sfs_opt_idname uidname;
  sfs_opt_idname gidname;
};
void *sfs_idnames_alloc ();
bool_t xdr_sfs_idnames (XDR *, void *);
RPC_STRUCT_DECL (sfs_idnames)

template<class T> bool
rpc_traverse (T &t, sfs_idnames &obj)
{
  return rpc_traverse (t, obj.uidname)
    && rpc_traverse (t, obj.gidname);
}


enum sfs_authtype {
  SFS_NOAUTH = 0,
  SFS_AUTHREQ = 1,
};
void *sfs_authtype_alloc ();
bool_t xdr_sfs_authtype (XDR *, void *);
RPC_ENUM_DECL (sfs_authtype)

template<class T> inline bool
rpc_traverse (T &t, sfs_authtype &obj)
{
  u_int32_t val = obj;
  if (!rpc_traverse (t, val))
    return false;
  obj = sfs_authtype (val);
  return true;
}


struct sfs_authreq {
  sfs_pubkey usrkey;
  sfs_sig signed_req;
};
void *sfs_authreq_alloc ();
bool_t xdr_sfs_authreq (XDR *, void *);
RPC_STRUCT_DECL (sfs_authreq)

template<class T> bool
rpc_traverse (T &t, sfs_authreq &obj)
{
  return rpc_traverse (t, obj.usrkey)
    && rpc_traverse (t, obj.signed_req);
}



struct sfs_autharg {
  const sfs_authtype type;
  union {
    union_entry_base _base;
    union_entry<sfs_authreq> req;
  };

#define rpcunion_tag_sfs_autharg type
#define rpcunion_switch_sfs_autharg(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case SFS_NOAUTH: \
    voidaction; \
    break; \
  case SFS_AUTHREQ: \
    action (sfs_authreq, req); \
    break; \
  default: \
    defaction; \
    break; \
  }

  sfs_autharg (sfs_authtype _tag = (sfs_authtype) 0) : type (_tag)
    { _base.init (); set_type (_tag); }
  sfs_autharg (const sfs_autharg &_s)
    : type (_s.type)
    { _base.init (_s._base); }
  ~sfs_autharg () { _base.destroy (); }
  sfs_autharg &operator= (const sfs_autharg &_s) {
    const_cast<sfs_authtype &> (type) = _s.type;
    _base.assign (_s._base);
    return *this;
  }

  void set_type (sfs_authtype _tag) {
    const_cast<sfs_authtype &> (type) = _tag;
    rpcunion_switch_sfs_autharg
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfs_autharg &obj)
{
  sfs_authtype tag = obj.type;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.type)
    obj.set_type (tag);

  rpcunion_switch_sfs_autharg
    (obj.type, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfs_autharg &obj)
{
  rpcunion_switch_sfs_autharg
    (obj.type, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfs_autharg_alloc ();
bool_t xdr_sfs_autharg (XDR *, void *);
RPC_UNION_DECL (sfs_autharg)


enum sfs_credtype {
  SFS_NOCRED = 0,
  SFS_UNIXCRED = 1,
};
void *sfs_credtype_alloc ();
bool_t xdr_sfs_credtype (XDR *, void *);
RPC_ENUM_DECL (sfs_credtype)

template<class T> inline bool
rpc_traverse (T &t, sfs_credtype &obj)
{
  u_int32_t val = obj;
  if (!rpc_traverse (t, val))
    return false;
  obj = sfs_credtype (val);
  return true;
}


struct sfs_unixcred {
  rpc_str<RPC_INFINITY> username;
  rpc_str<RPC_INFINITY> homedir;
  rpc_str<RPC_INFINITY> shell;
  u_int32_t uid;
  u_int32_t gid;
  rpc_vec<u_int32_t, RPC_INFINITY> groups;
};
void *sfs_unixcred_alloc ();
bool_t xdr_sfs_unixcred (XDR *, void *);
RPC_STRUCT_DECL (sfs_unixcred)

template<class T> bool
rpc_traverse (T &t, sfs_unixcred &obj)
{
  return rpc_traverse (t, obj.username)
    && rpc_traverse (t, obj.homedir)
    && rpc_traverse (t, obj.shell)
    && rpc_traverse (t, obj.uid)
    && rpc_traverse (t, obj.gid)
    && rpc_traverse (t, obj.groups);
}



struct sfs_cred {
  const sfs_credtype type;
  union {
    union_entry_base _base;
    union_entry<sfs_unixcred> unixcred;
  };

#define rpcunion_tag_sfs_cred type
#define rpcunion_switch_sfs_cred(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case SFS_NOCRED: \
    voidaction; \
    break; \
  case SFS_UNIXCRED: \
    action (sfs_unixcred, unixcred); \
    break; \
  default: \
    defaction; \
    break; \
  }

  sfs_cred (sfs_credtype _tag = (sfs_credtype) 0) : type (_tag)
    { _base.init (); set_type (_tag); }
  sfs_cred (const sfs_cred &_s)
    : type (_s.type)
    { _base.init (_s._base); }
  ~sfs_cred () { _base.destroy (); }
  sfs_cred &operator= (const sfs_cred &_s) {
    const_cast<sfs_credtype &> (type) = _s.type;
    _base.assign (_s._base);
    return *this;
  }

  void set_type (sfs_credtype _tag) {
    const_cast<sfs_credtype &> (type) = _tag;
    rpcunion_switch_sfs_cred
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfs_cred &obj)
{
  sfs_credtype tag = obj.type;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.type)
    obj.set_type (tag);

  rpcunion_switch_sfs_cred
    (obj.type, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfs_cred &obj)
{
  rpcunion_switch_sfs_cred
    (obj.type, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfs_cred_alloc ();
bool_t xdr_sfs_cred (XDR *, void *);
RPC_UNION_DECL (sfs_cred)



struct sfs_loginokres {
  sfs_cred cred;
  sfs_hash authid;
  sfs_seqno seqno;
};
void *sfs_loginokres_alloc ();
bool_t xdr_sfs_loginokres (XDR *, void *);
RPC_STRUCT_DECL (sfs_loginokres)

template<class T> bool
rpc_traverse (T &t, sfs_loginokres &obj)
{
  return rpc_traverse (t, obj.cred)
    && rpc_traverse (t, obj.authid)
    && rpc_traverse (t, obj.seqno);
}


enum sfs_loginstat {
  SFSLOGIN_OK = 0,
  SFSLOGIN_MORE = 1,
  SFSLOGIN_BAD = 2,
  SFSLOGIN_ALLBAD = 3,
};
void *sfs_loginstat_alloc ();
bool_t xdr_sfs_loginstat (XDR *, void *);
RPC_ENUM_DECL (sfs_loginstat)

template<class T> inline bool
rpc_traverse (T &t, sfs_loginstat &obj)
{
  u_int32_t val = obj;
  if (!rpc_traverse (t, val))
    return false;
  obj = sfs_loginstat (val);
  return true;
}


struct sfsauth_loginres {
  const sfs_loginstat status;
  union {
    union_entry_base _base;
    union_entry<sfs_loginokres> resok;
    union_entry<rpc_bytes<RPC_INFINITY> > resmore;
  };

#define rpcunion_tag_sfsauth_loginres status
#define rpcunion_switch_sfsauth_loginres(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case SFSLOGIN_OK: \
    action (sfs_loginokres, resok); \
    break; \
  case SFSLOGIN_MORE: \
    action (opaque, resmore); \
    break; \
  case SFSLOGIN_BAD: \
  case SFSLOGIN_ALLBAD: \
    voidaction; \
    break; \
  default: \
    defaction; \
    break; \
  }

  sfsauth_loginres (sfs_loginstat _tag = (sfs_loginstat) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfsauth_loginres (const sfsauth_loginres &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfsauth_loginres () { _base.destroy (); }
  sfsauth_loginres &operator= (const sfsauth_loginres &_s) {
    const_cast<sfs_loginstat &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (sfs_loginstat _tag) {
    const_cast<sfs_loginstat &> (status) = _tag;
    rpcunion_switch_sfsauth_loginres
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsauth_loginres &obj)
{
  sfs_loginstat tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfsauth_loginres
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsauth_loginres &obj)
{
  rpcunion_switch_sfsauth_loginres
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsauth_loginres_alloc ();
bool_t xdr_sfsauth_loginres (XDR *, void *);
RPC_UNION_DECL (sfsauth_loginres)



struct sfs_loginres {
  const sfs_loginstat status;
  union {
    union_entry_base _base;
    union_entry<u_int32_t> authno;
    union_entry<rpc_bytes<RPC_INFINITY> > resmore;
  };

#define rpcunion_tag_sfs_loginres status
#define rpcunion_switch_sfs_loginres(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case SFSLOGIN_OK: \
    action (u_int32_t, authno); \
    break; \
  case SFSLOGIN_MORE: \
    action (opaque, resmore); \
    break; \
  case SFSLOGIN_BAD: \
  case SFSLOGIN_ALLBAD: \
    voidaction; \
    break; \
  default: \
    defaction; \
    break; \
  }

  sfs_loginres (sfs_loginstat _tag = (sfs_loginstat) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfs_loginres (const sfs_loginres &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfs_loginres () { _base.destroy (); }
  sfs_loginres &operator= (const sfs_loginres &_s) {
    const_cast<sfs_loginstat &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (sfs_loginstat _tag) {
    const_cast<sfs_loginstat &> (status) = _tag;
    rpcunion_switch_sfs_loginres
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfs_loginres &obj)
{
  sfs_loginstat tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfs_loginres
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfs_loginres &obj)
{
  rpcunion_switch_sfs_loginres
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfs_loginres_alloc ();
bool_t xdr_sfs_loginres (XDR *, void *);
RPC_UNION_DECL (sfs_loginres)



struct sfs_loginarg {
  sfs_seqno seqno;
  rpc_bytes<RPC_INFINITY> certificate;
};
void *sfs_loginarg_alloc ();
bool_t xdr_sfs_loginarg (XDR *, void *);
RPC_STRUCT_DECL (sfs_loginarg)

template<class T> bool
rpc_traverse (T &t, sfs_loginarg &obj)
{
  return rpc_traverse (t, obj.seqno)
    && rpc_traverse (t, obj.certificate);
}


enum sfsauth_srpstat {
  SFSAUTH_SRP_OK = 0,
  SFSAUTH_SRP_NOTTHERE = 1,
  SFSAUTH_SRP_PHASE0 = 2,
  SFSAUTH_SRP_PHASE1 = 3,
  SFSAUTH_SRP_PHASE2 = 4,
  SFSAUTH_SRP_BADSRPINFO = 5,
};
void *sfsauth_srpstat_alloc ();
bool_t xdr_sfsauth_srpstat (XDR *, void *);
RPC_ENUM_DECL (sfsauth_srpstat)

template<class T> inline bool
rpc_traverse (T &t, sfsauth_srpstat &obj)
{
  u_int32_t val = obj;
  if (!rpc_traverse (t, val))
    return false;
  obj = sfsauth_srpstat (val);
  return true;
}


struct sfsauth_srpinfo {
  rpc_str<RPC_INFINITY> prime;
  rpc_str<RPC_INFINITY> generator;
  rpc_str<RPC_INFINITY> salt;
  rpc_str<RPC_INFINITY> verifier;
  rpc_str<RPC_INFINITY> seckey;
};
void *sfsauth_srpinfo_alloc ();
bool_t xdr_sfsauth_srpinfo (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_srpinfo)

template<class T> bool
rpc_traverse (T &t, sfsauth_srpinfo &obj)
{
  return rpc_traverse (t, obj.prime)
    && rpc_traverse (t, obj.generator)
    && rpc_traverse (t, obj.salt)
    && rpc_traverse (t, obj.verifier)
    && rpc_traverse (t, obj.seckey);
}



struct sfsauth_sesskeydat {
  sfs_msgtype type;
  rpc_bytes<RPC_INFINITY> key;
};
void *sfsauth_sesskeydat_alloc ();
bool_t xdr_sfsauth_sesskeydat (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_sesskeydat)

template<class T> bool
rpc_traverse (T &t, sfsauth_sesskeydat &obj)
{
  return rpc_traverse (t, obj.type)
    && rpc_traverse (t, obj.key);
}



struct sfsauth_srp0arg {
  rpc_str<RPC_INFINITY> username;
};
void *sfsauth_srp0arg_alloc ();
bool_t xdr_sfsauth_srp0arg (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_srp0arg)

template<class T> inline bool
rpc_traverse (T &t, sfsauth_srp0arg &obj)
{
  return rpc_traverse (t, obj.username);
}



struct sfsauth_srp0resok {
  rpc_str<RPC_INFINITY> prime;
  rpc_str<RPC_INFINITY> generator;
};
void *sfsauth_srp0resok_alloc ();
bool_t xdr_sfsauth_srp0resok (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_srp0resok)

template<class T> bool
rpc_traverse (T &t, sfsauth_srp0resok &obj)
{
  return rpc_traverse (t, obj.prime)
    && rpc_traverse (t, obj.generator);
}



struct sfsauth_srp0res {
  const sfsauth_srpstat status;
  union {
    union_entry_base _base;
    union_entry<sfsauth_srp0resok> resok;
  };

#define rpcunion_tag_sfsauth_srp0res status
#define rpcunion_switch_sfsauth_srp0res(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case SFSAUTH_SRP_OK: \
    action (sfsauth_srp0resok, resok); \
    break; \
  default: \
    voidaction; \
    break; \
  }

  sfsauth_srp0res (sfsauth_srpstat _tag = (sfsauth_srpstat) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfsauth_srp0res (const sfsauth_srp0res &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfsauth_srp0res () { _base.destroy (); }
  sfsauth_srp0res &operator= (const sfsauth_srp0res &_s) {
    const_cast<sfsauth_srpstat &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (sfsauth_srpstat _tag) {
    const_cast<sfsauth_srpstat &> (status) = _tag;
    rpcunion_switch_sfsauth_srp0res
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsauth_srp0res &obj)
{
  sfsauth_srpstat tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfsauth_srp0res
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsauth_srp0res &obj)
{
  rpcunion_switch_sfsauth_srp0res
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsauth_srp0res_alloc ();
bool_t xdr_sfsauth_srp0res (XDR *, void *);
RPC_UNION_DECL (sfsauth_srp0res)



struct sfsauth_srp1arg {
  rpc_str<RPC_INFINITY> A;
};
void *sfsauth_srp1arg_alloc ();
bool_t xdr_sfsauth_srp1arg (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_srp1arg)

template<class T> inline bool
rpc_traverse (T &t, sfsauth_srp1arg &obj)
{
  return rpc_traverse (t, obj.A);
}



struct sfsauth_srp1resok {
  rpc_str<RPC_INFINITY> salt;
  rpc_str<RPC_INFINITY> B;
  rpc_str<RPC_INFINITY> u;
};
void *sfsauth_srp1resok_alloc ();
bool_t xdr_sfsauth_srp1resok (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_srp1resok)

template<class T> bool
rpc_traverse (T &t, sfsauth_srp1resok &obj)
{
  return rpc_traverse (t, obj.salt)
    && rpc_traverse (t, obj.B)
    && rpc_traverse (t, obj.u);
}



struct sfsauth_srp1res {
  const sfsauth_srpstat status;
  union {
    union_entry_base _base;
    union_entry<sfsauth_srp1resok> resok;
  };

#define rpcunion_tag_sfsauth_srp1res status
#define rpcunion_switch_sfsauth_srp1res(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case SFSAUTH_SRP_OK: \
    action (sfsauth_srp1resok, resok); \
    break; \
  default: \
    voidaction; \
    break; \
  }

  sfsauth_srp1res (sfsauth_srpstat _tag = (sfsauth_srpstat) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfsauth_srp1res (const sfsauth_srp1res &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfsauth_srp1res () { _base.destroy (); }
  sfsauth_srp1res &operator= (const sfsauth_srp1res &_s) {
    const_cast<sfsauth_srpstat &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (sfsauth_srpstat _tag) {
    const_cast<sfsauth_srpstat &> (status) = _tag;
    rpcunion_switch_sfsauth_srp1res
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsauth_srp1res &obj)
{
  sfsauth_srpstat tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfsauth_srp1res
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsauth_srp1res &obj)
{
  rpcunion_switch_sfsauth_srp1res
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsauth_srp1res_alloc ();
bool_t xdr_sfsauth_srp1res (XDR *, void *);
RPC_UNION_DECL (sfsauth_srp1res)



struct sfsauth_srp2arg {
  sfs_hash clntproof;
};
void *sfsauth_srp2arg_alloc ();
bool_t xdr_sfsauth_srp2arg (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_srp2arg)

template<class T> inline bool
rpc_traverse (T &t, sfsauth_srp2arg &obj)
{
  return rpc_traverse (t, obj.clntproof);
}



struct sfsauth_srp2resok {
  sfs_hash servproof;
};
void *sfsauth_srp2resok_alloc ();
bool_t xdr_sfsauth_srp2resok (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_srp2resok)

template<class T> inline bool
rpc_traverse (T &t, sfsauth_srp2resok &obj)
{
  return rpc_traverse (t, obj.servproof);
}



struct sfsauth_srp2res {
  const sfsauth_srpstat status;
  union {
    union_entry_base _base;
    union_entry<sfsauth_srp2resok> resok;
  };

#define rpcunion_tag_sfsauth_srp2res status
#define rpcunion_switch_sfsauth_srp2res(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case SFSAUTH_SRP_OK: \
    action (sfsauth_srp2resok, resok); \
    break; \
  default: \
    voidaction; \
    break; \
  }

  sfsauth_srp2res (sfsauth_srpstat _tag = (sfsauth_srpstat) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfsauth_srp2res (const sfsauth_srp2res &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfsauth_srp2res () { _base.destroy (); }
  sfsauth_srp2res &operator= (const sfsauth_srp2res &_s) {
    const_cast<sfsauth_srpstat &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (sfsauth_srpstat _tag) {
    const_cast<sfsauth_srpstat &> (status) = _tag;
    rpcunion_switch_sfsauth_srp2res
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsauth_srp2res &obj)
{
  sfsauth_srpstat tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfsauth_srp2res
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsauth_srp2res &obj)
{
  rpcunion_switch_sfsauth_srp2res
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsauth_srp2res_alloc ();
bool_t xdr_sfsauth_srp2res (XDR *, void *);
RPC_UNION_DECL (sfsauth_srp2res)


enum sfsauth_fetchstat {
  SFSAUTH_FETCH_OK = 0,
  SFSAUTH_FETCH_FAILED = 1,
};
void *sfsauth_fetchstat_alloc ();
bool_t xdr_sfsauth_fetchstat (XDR *, void *);
RPC_ENUM_DECL (sfsauth_fetchstat)

template<class T> inline bool
rpc_traverse (T &t, sfsauth_fetchstat &obj)
{
  u_int32_t val = obj;
  if (!rpc_traverse (t, val))
    return false;
  obj = sfsauth_fetchstat (val);
  return true;
}


struct sfsauth_fetchresok {
  rpc_str<RPC_INFINITY> seckey;
  sfs_hash hostid;
};
void *sfsauth_fetchresok_alloc ();
bool_t xdr_sfsauth_fetchresok (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_fetchresok)

template<class T> bool
rpc_traverse (T &t, sfsauth_fetchresok &obj)
{
  return rpc_traverse (t, obj.seckey)
    && rpc_traverse (t, obj.hostid);
}



struct sfsauth_fetchres {
  const sfsauth_fetchstat status;
  union {
    union_entry_base _base;
    union_entry<sfsauth_fetchresok> resok;
  };

#define rpcunion_tag_sfsauth_fetchres status
#define rpcunion_switch_sfsauth_fetchres(swarg, action, voidaction, defaction) \
  switch (swarg) { \
  case SFSAUTH_FETCH_OK: \
    action (sfsauth_fetchresok, resok); \
    break; \
  default: \
    voidaction; \
    break; \
  }

  sfsauth_fetchres (sfsauth_fetchstat _tag = (sfsauth_fetchstat) 0) : status (_tag)
    { _base.init (); set_status (_tag); }
  sfsauth_fetchres (const sfsauth_fetchres &_s)
    : status (_s.status)
    { _base.init (_s._base); }
  ~sfsauth_fetchres () { _base.destroy (); }
  sfsauth_fetchres &operator= (const sfsauth_fetchres &_s) {
    const_cast<sfsauth_fetchstat &> (status) = _s.status;
    _base.assign (_s._base);
    return *this;
  }

  void set_status (sfsauth_fetchstat _tag) {
    const_cast<sfsauth_fetchstat &> (status) = _tag;
    rpcunion_switch_sfsauth_fetchres
      (_tag, RPCUNION_SET, _base.destroy (), _base.destroy ());
  }
};

template<class T> bool
rpc_traverse (T &t, sfsauth_fetchres &obj)
{
  sfsauth_fetchstat tag = obj.status;
  if (!rpc_traverse (t, tag))
    return false;
  if (tag != obj.status)
    obj.set_status (tag);

  rpcunion_switch_sfsauth_fetchres
    (obj.status, RPCUNION_TRAVERSE, return true, return false);
}
inline bool
rpc_traverse (stompcast_t &s, sfsauth_fetchres &obj)
{
  rpcunion_switch_sfsauth_fetchres
    (obj.status, RPCUNION_REC_STOMPCAST,
     obj._base.destroy (); return true, obj._base.destroy (); return true;);
}
void *sfsauth_fetchres_alloc ();
bool_t xdr_sfsauth_fetchres (XDR *, void *);
RPC_UNION_DECL (sfsauth_fetchres)



struct sfsauth_registerarg {
  rpc_str<RPC_INFINITY> username;
  rpc_str<RPC_INFINITY> password;
  sfs_pubkey pubkey;
  rpc_ptr<sfsauth_srpinfo> srpinfo;
};
void *sfsauth_registerarg_alloc ();
bool_t xdr_sfsauth_registerarg (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_registerarg)

template<class T> bool
rpc_traverse (T &t, sfsauth_registerarg &obj)
{
  return rpc_traverse (t, obj.username)
    && rpc_traverse (t, obj.password)
    && rpc_traverse (t, obj.pubkey)
    && rpc_traverse (t, obj.srpinfo);
}


enum sfsauth_registerres {
  SFSAUTH_REGISTER_OK = 0,
  SFSAUTH_REGISTER_NOTSOCK = 1,
  SFSAUTH_REGISTER_BADUSERNAME = 2,
  SFSAUTH_REGISTER_WRONGUID = 3,
  SFSAUTH_REGISTER_DENYROOT = 4,
  SFSAUTH_REGISTER_BADSHELL = 5,
  SFSAUTH_REGISTER_DENYFILE = 6,
  SFSAUTH_REGISTER_BADPASSWORD = 7,
  SFSAUTH_REGISTER_USEREXISTS = 8,
  SFSAUTH_REGISTER_FAILED = 9,
};
void *sfsauth_registerres_alloc ();
bool_t xdr_sfsauth_registerres (XDR *, void *);
RPC_ENUM_DECL (sfsauth_registerres)

template<class T> inline bool
rpc_traverse (T &t, sfsauth_registerres &obj)
{
  u_int32_t val = obj;
  if (!rpc_traverse (t, val))
    return false;
  obj = sfsauth_registerres (val);
  return true;
}


struct sfsauth_updatereq {
  sfs_msgtype type;
  sfs_hash authid;
  sfs_pubkey oldkey;
  sfs_pubkey newkey;
  rpc_ptr<sfsauth_srpinfo> srpinfo;
};
void *sfsauth_updatereq_alloc ();
bool_t xdr_sfsauth_updatereq (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_updatereq)

template<class T> bool
rpc_traverse (T &t, sfsauth_updatereq &obj)
{
  return rpc_traverse (t, obj.type)
    && rpc_traverse (t, obj.authid)
    && rpc_traverse (t, obj.oldkey)
    && rpc_traverse (t, obj.newkey)
    && rpc_traverse (t, obj.srpinfo);
}



struct sfsauth_updatearg {
  sfsauth_updatereq updatereq;
  sfs_sig signature;
};
void *sfsauth_updatearg_alloc ();
bool_t xdr_sfsauth_updatearg (XDR *, void *);
RPC_STRUCT_DECL (sfsauth_updatearg)

template<class T> bool
rpc_traverse (T &t, sfsauth_updatearg &obj)
{
  return rpc_traverse (t, obj.updatereq)
    && rpc_traverse (t, obj.signature);
}


enum sfsauth_updateres {
  SFSAUTH_UPDATE_OK = 0,
  SFSAUTH_UPDATE_BADSIGNATURE = 1,
  SFSAUTH_UPDATE_PROTOERR = 2,
  SFSAUTH_UPDATE_NOTTHERE = 3,
  SFSAUTH_UPDATE_BADAUTHID = 4,
  SFSAUTH_UPDATE_DENYFILE = 5,
  SFSAUTH_UPDATE_FAILED = 6,
};
void *sfsauth_updateres_alloc ();
bool_t xdr_sfsauth_updateres (XDR *, void *);
RPC_ENUM_DECL (sfsauth_updateres)

template<class T> inline bool
rpc_traverse (T &t, sfsauth_updateres &obj)
{
  u_int32_t val = obj;
  if (!rpc_traverse (t, val))
    return false;
  obj = sfsauth_updateres (val);
  return true;
}

#ifndef SFS_PROGRAM
#define SFS_PROGRAM 344440
#endif /* !SFS_PROGRAM */
extern const rpc_program sfs_program_1;
enum { SFS_VERSION = 1 };
enum {
  SFSPROC_NULL = 0,
  SFSPROC_CONNECT = 1,
  SFSPROC_ENCRYPT = 2,
  SFSPROC_GETFSINFO = 3,
  SFSPROC_LOGIN = 4,
  SFSPROC_LOGOUT = 5,
  SFSPROC_IDNAMES = 6,
  SFSPROC_IDNUMS = 7,
  SFSPROC_GETCRED = 8,
};
#define SFS_PROGRAM_1_APPLY_NOVOID(macro, void) \
  macro (SFSPROC_NULL, void, void) \
  macro (SFSPROC_CONNECT, sfs_connectarg, sfs_connectres) \
  macro (SFSPROC_ENCRYPT, sfs_encryptarg, sfs_encryptres) \
  macro (SFSPROC_GETFSINFO, void, sfs_fsinfo) \
  macro (SFSPROC_LOGIN, sfs_loginarg, sfs_loginres) \
  macro (SFSPROC_LOGOUT, u_int32_t, void) \
  macro (SFSPROC_IDNAMES, sfs_idnums, sfs_idnames) \
  macro (SFSPROC_IDNUMS, sfs_idnames, sfs_idnums) \
  macro (SFSPROC_GETCRED, void, sfs_cred)
#define SFS_PROGRAM_1_APPLY(macro) \
  SFS_PROGRAM_1_APPLY_NOVOID(macro, void)


#ifndef SFSCB_PROGRAM
#define SFSCB_PROGRAM 344441
#endif /* !SFSCB_PROGRAM */
extern const rpc_program sfscb_program_1;
enum { SFSCB_VERSION = 1 };
enum {
  SFSCBPROC_NULL = 0,
};
#define SFSCB_PROGRAM_1_APPLY_NOVOID(macro, void) \
  macro (SFSCBPROC_NULL, void, void)
#define SFSCB_PROGRAM_1_APPLY(macro) \
  SFSCB_PROGRAM_1_APPLY_NOVOID(macro, void)


#ifndef SFSAUTH_PROGRAM
#define SFSAUTH_PROGRAM 344442
#endif /* !SFSAUTH_PROGRAM */
extern const rpc_program sfsauth_program_1;
enum { SFSAUTH_VERSION = 1 };
enum {
  SFSAUTHPROC_NULL = 0,
  SFSAUTHPROC_LOGIN = 1,
  SFSAUTHPROC_REGISTER = 2,
  SFSAUTHPROC_UPDATE = 3,
  SFSAUTHPROC_SRP_GETGLOBALPARAMS = 4,
  SFSAUTHPROC_SRP_PHASE0 = 5,
  SFSAUTHPROC_SRP_PHASE1 = 6,
  SFSAUTHPROC_SRP_PHASE2 = 7,
  SFSAUTHPROC_FETCH = 8,
};
#define SFSAUTH_PROGRAM_1_APPLY_NOVOID(macro, void) \
  macro (SFSAUTHPROC_NULL, void, void) \
  macro (SFSAUTHPROC_LOGIN, sfs_loginarg, sfsauth_loginres) \
  macro (SFSAUTHPROC_REGISTER, sfsauth_registerarg, sfsauth_registerres) \
  macro (SFSAUTHPROC_UPDATE, sfsauth_updatearg, sfsauth_updateres) \
  macro (SFSAUTHPROC_SRP_GETGLOBALPARAMS, void, sfsauth_srpinfo) \
  macro (SFSAUTHPROC_SRP_PHASE0, sfsauth_srp0arg, sfsauth_srp0res) \
  macro (SFSAUTHPROC_SRP_PHASE1, sfsauth_srp1arg, sfsauth_srp1res) \
  macro (SFSAUTHPROC_SRP_PHASE2, sfsauth_srp2arg, sfsauth_srp2res) \
  macro (SFSAUTHPROC_FETCH, void, sfsauth_fetchres)
#define SFSAUTH_PROGRAM_1_APPLY(macro) \
  SFSAUTH_PROGRAM_1_APPLY_NOVOID(macro, void)

#endif /* !__RPCC_SFS_PROT_H_INCLUDED__ */
